package org.stm.metric.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.stm.metric.entity.MetricApiCfg;
import org.stm.metric.service.IMetricApiCfgService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.List;

/**
 * @Description: 指标获取接口配置
 * @Author: jeecg-boot
 * @Date:   2023-11-06
 * @Version: V1.0
 */
@Api(tags="指标获取接口配置")
@RestController
@RequestMapping("/metric/metricApiCfg")
@Slf4j
public class MetricApiCfgController extends JeecgController<MetricApiCfg, IMetricApiCfgService> {
	@Autowired
	private IMetricApiCfgService metricApiCfgService;

	/**
	 * 分页列表查询
	 *
	 * @param metricApiCfg
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "指标获取接口配置-分页列表查询")
	@ApiOperation(value="指标获取接口配置-分页列表查询", notes="指标获取接口配置-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<MetricApiCfg>> queryPageList(MetricApiCfg metricApiCfg,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {
		QueryWrapper<MetricApiCfg> queryWrapper = QueryGenerator.initQueryWrapper(metricApiCfg, req.getParameterMap());
		Page<MetricApiCfg> page = new Page<MetricApiCfg>(pageNo, pageSize);
		IPage<MetricApiCfg> pageList = metricApiCfgService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param metricApiCfg
	 * @return
	 */
	@AutoLog(value = "指标获取接口配置-添加")
	@ApiOperation(value="指标获取接口配置-添加", notes="指标获取接口配置-添加")
	@RequiresPermissions("metric:metric_api_cfg:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody MetricApiCfg metricApiCfg) {
		metricApiCfgService.save(metricApiCfg);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param metricApiCfg
	 * @return
	 */
	@AutoLog(value = "指标获取接口配置-编辑")
	@ApiOperation(value="指标获取接口配置-编辑", notes="指标获取接口配置-编辑")
	@RequiresPermissions("metric:metric_api_cfg:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody MetricApiCfg metricApiCfg) {
		metricApiCfgService.updateById(metricApiCfg);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "指标获取接口配置-通过id删除")
	@ApiOperation(value="指标获取接口配置-通过id删除", notes="指标获取接口配置-通过id删除")
	@RequiresPermissions("metric:metric_api_cfg:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		metricApiCfgService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "指标获取接口配置-批量删除")
	@ApiOperation(value="指标获取接口配置-批量删除", notes="指标获取接口配置-批量删除")
	@RequiresPermissions("metric:metric_api_cfg:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.metricApiCfgService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "指标获取接口配置-通过id查询")
	@ApiOperation(value="指标获取接口配置-通过id查询", notes="指标获取接口配置-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<MetricApiCfg> queryById(@RequestParam(name="id",required=true) String id) {
		MetricApiCfg metricApiCfg = metricApiCfgService.getById(id);
		if(metricApiCfg==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(metricApiCfg);
	}

	 @GetMapping(value = "/queryAll")
	 public Result<List<MetricApiCfg>> queryAll(MetricApiCfg metricApiCfg) {
		 QueryWrapper<MetricApiCfg> queryWrapper = new QueryWrapper<>();
		 queryWrapper.eq("mtrc_no",metricApiCfg.getMtrcNo());
		 List<MetricApiCfg> list = metricApiCfgService.list(queryWrapper);
		 return Result.OK(list);
	 }

    /**
    * 导出excel
    *
    * @param request
    * @param metricApiCfg
    */
    @RequiresPermissions("metric:metric_api_cfg:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, MetricApiCfg metricApiCfg) {
        return super.exportXls(request, metricApiCfg, MetricApiCfg.class, "指标获取接口配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("metric:metric_api_cfg:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, MetricApiCfg.class);
    }
}

